package MT::Plugin::GOBLIN;
;########################################################################
;### mt-goblin.pl
;### 		Programmed by Piroli YUKARINOMIYA (Open MagicVox)
;### 		@see http://www.magicvox.net/archive/2005/10192350.php

;### GOBLIN is "General Open-ended BlackList Inheritance Network" ;)

use strict;
use MT::Template::Context;

;### Add the path string to your blacklist.
our @BListPath = ();
push @BListPath, '/home/magicvox/www/cgi-bin/mt/plugins/goblin/goblin.txt';
push @BListPath, '/home/magicvox/www/your/additional/blacklist.txt';
push @BListPath, '/home/magicvox/www/your/additional/blacklist2.txt';
push @BListPath, '/home/magicvox/www/your/additional/blacklist3.txt';
;### as much as like above...



;### Registering as plugin
if (MT->can ('add_plugin')) {
	require MT::Plugin;
	my $plugin = MT::Plugin->new;
		$plugin->name (__PACKAGE__. ' ver 0.11 (Release 1115)');
		$plugin->description ('Deny comments and trackbacks from the spammer in my BlackList');
		$plugin->doc_link ('http://www.magicvox.net/archive/2005/10192350.php');
	MT->add_plugin ($plugin);
	;# Registering callback procedures
	MT->add_callback ('CommentFilter', 2, $plugin, \&CommentFilter);
	MT->add_callback ('TBPingFilter', 2, $plugin, \&TBPingFilter);
}



;### CommentFilter
sub CommentFilter {
	my ($eh, $app, $comment) = @_;
	if (isInBlackList ($app->remote_ip)) {
		$app->log (__PACKAGE__. " : Deny a comment from ". $app->remote_ip);
		return 0;
	}
	return 1;
}

;### TBPingFilter
sub TBPingFilter {
	my ($eh, $app, $tbping) = @_;
	if (isInBlackList ($app->remote_ip)) {
		$app->log (__PACKAGE__. " : Deny a trackback ping from ". $app->remote_ip);
		return 0;
	}
	return 1;
}



;### Check whether specified remote address is in black lists
sub isInBlackList {
	my $src_ip = shift;
	foreach my $blist (@BListPath) {
		if (open (BLACKLIST, "<$blist")) {
			while (<BLACKLIST>) {
				my ($ip) = $_ =~ /^([\d\.]+)/;
				if ($ip ne "" && $src_ip =~ m/^\Q$ip\E$/i) {
					close (BLACKLIST);
					return 1;
				}
			}
			close (BLACKLIST);
		}
	}
	return 0;
}



1;
